#![cfg(all(not(feature = "only-sig-bypass"), feature = "regular"))]
#![allow(unused)]

const CURL_OPT_TYPE_LONG: u64 = 0;
const CURL_OPT_TYPE_OBJECT_POINT: u64 = 10000;
const CURL_OPT_TYPE_FUNCTION_POINT: u64 = 20000;
const CURL_OPT_TYPE_OFF_T: u64 = 30000;
const CURL_OPT_TYPE_BLOB: u64 = 40000;

const CURL_OPT_TYPE_STRING_POINT: u64 = CURL_OPT_TYPE_OBJECT_POINT;
const CURL_OPT_TYPE_S_LIST_POINT: u64 = CURL_OPT_TYPE_OBJECT_POINT;
const CURL_OPT_TYPE_CB_POINT: u64 = CURL_OPT_TYPE_OBJECT_POINT;
const CURL_OPT_TYPE_VALUES: u64 = CURL_OPT_TYPE_LONG;

#[macro_export]
macro_rules! curl_opt {
    ($name:ident, $typ:ident, $value:literal) => {
        pub(crate) const $name: u64 = $typ + $value;
    };
}

curl_opt!(CURL_OPT_URL, CURL_OPT_TYPE_STRING_POINT, 2);
curl_opt!(CURL_OPT_SSL_VERIFY_PEER, CURL_OPT_TYPE_LONG, 64);
curl_opt!(CURL_OPT_CA_INFO, CURL_OPT_TYPE_STRING_POINT, 65);
curl_opt!(CURL_OPT_SSL_VERIFY_HOST, CURL_OPT_TYPE_LONG, 81);
curl_opt!(CURL_OPT_CA_PATH, CURL_OPT_TYPE_STRING_POINT, 97);