use std::sync::OnceLock;
use std::thread;
use std::time::Duration;

use ilhook::x64::Registers;
use interceptor_rs::Interceptor;
use unreal_niggery_rs::Add;
use unreal_niggery_rs::f_string::{FString, Printf};
use unreal_niggery_rs::t_array::TArray;
use windows::core::{PCSTR, PCWSTR};
use windows::Win32::Foundation::HINSTANCE;
use windows::Win32::System::Console;
use windows::Win32::System::LibraryLoader::GetModuleHandleA;
use windows::Win32::System::SystemServices::DLL_PROCESS_ATTACH;

use config::CONFIG;

mod config;
#[cfg(all(not(feature = "only-sig-bypass"), feature = "regular"))]
mod replacer;
#[cfg(all(not(feature = "only-sig-bypass"), feature = "regular"))]
mod extras;
#[cfg(all(not(feature = "only-sig-bypass"), feature = "regular"))]
mod curl_utils;

static CUSTOM_PAK_FOLDER: OnceLock<String> = OnceLock::new();

fn thread_func() {
    unsafe { Console::AllocConsole() }.unwrap();
    println!("Wuthering Waves essential binary patcher");
    println!("Don't forget to visit https://discord.gg/reversedrooms");

    println!("Waiting for ACE init");
    let module = unsafe { GetModuleHandleA(PCSTR::null()) }.unwrap();
    let pak_file_offset = ((module.0 as usize) + CONFIG.f_pak_file_check) as *const u64;
    loop {
        if unsafe { std::ptr::read(pak_file_offset) } == CONFIG.f_pak_file_check_preamble {
            println!("ACE Initialization finished");
            break;
        }
        thread::sleep(Duration::from_millis(1))
    }

    let mut interceptor = Interceptor::new();
    interceptor
        .replace((module.0 as usize) + CONFIG.f_pak_file_check, fpakfile_check_replacement, None)
        .unwrap();

    TArray::set_t_array_resize_grow_ptr(module.0 as usize + CONFIG.resize_grow);
    FString::set_f_string_printf_ptr(module.0 as usize + CONFIG.f_print_f);

    if let Ok(value) = std::env::var("CFG_WUWA_CUSTOM_PAK_DIR") {
        println!("Found custom location for pak files: {value}");
        let _ = CUSTOM_PAK_FOLDER.set(value).unwrap();
        interceptor
            .attach((module.0 as usize) + CONFIG.add_pak_folders_entry, add_pak_folders, None)
            .unwrap();
        interceptor
            .attach((module.0 as usize) + CONFIG.add_pak_folders_ret, debug_get_pak_folders, None)
            .unwrap();
    }

    #[cfg(all(not(feature = "only-sig-bypass"), feature = "regular", feature = "advanced"))]
    wicked_waifus_win_payload_advanced::enable_advanced_features(
        module.0 as usize,
        &mut interceptor,
        &wicked_waifus_win_payload_advanced::AdvancedConfig {
            enable_debug_view: false,
            enable_dev_tools: false,
            enable_dump_paks: false,
            enable_dump_buffer_contents: false,
            enable_hook_find_file_in_pak: false,
        }
    );

    #[cfg(all(not(feature = "only-sig-bypass"), feature = "regular"))]
    extras::configure_extras(&mut interceptor);

    println!("Successfully initialized!");

    thread::sleep(Duration::from_secs(u64::MAX));
}

unsafe extern "win64" fn fpakfile_check_replacement(
    reg: *mut Registers,
    _: usize,
    _: usize,
) -> usize {
    let wstr = *(((*reg).rcx + 8) as *const usize) as *const u16;
    let pak_name = PCWSTR::from_raw(wstr).to_string().unwrap();
    println!("Trying to verify pak: {pak_name}, returning true");

    1
}

unsafe extern "win64" fn add_pak_folders(reg: *mut Registers, _: usize) {
    let local_ptr = ((*reg).rbp - 0x20) as usize; // Uninitialized local FString pointer
    let pak_folder = CUSTOM_PAK_FOLDER.get().unwrap();
    FString::printf(local_ptr, pak_folder);
    let mut f_string = FString(TArray::read(local_ptr));
    println!("Injecting custom pak folder: {}", f_string);
    TArray::read((*reg).rdx as usize).add(&mut f_string.0);
}

unsafe extern "win64" fn debug_get_pak_folders(reg: *mut Registers, _: usize) {
    println!("Loading Paks from: {}", TArray::read((*reg).rbx as usize));
}

#[no_mangle]
unsafe extern "system" fn DllMain(_: HINSTANCE, call_reason: u32, _: *mut ()) -> bool {
    if call_reason == DLL_PROCESS_ATTACH {
        thread::spawn(|| thread_func());
    }

    true
}